; Programme assembleur pour 80x86 utilisant les macro-commandes.
; fichier ex-sais.asm.
; Saisie d'un nombre, modification et affichage.
; Bertrand Ducourthial. Mars 1998. Version 1.

ASSUME CS:CODE, DS:DONNEES

DONNEES SEGMENT
        invite  DB     10,13,"Voulez-vous recommencer (O/N) ? : $"
DONNEES ENDS

CODE    SEGMENT
                INCLUDE macinit.inc    ; Segment de donnees pour les macros.
                INCLUDE macaffi.inc    ; Macro-commandes d'affichage.
                INCLUDE macsais.inc    ; Macro-commandes de saisie.
                INCLUDE macconv.inc    ; Macro-commandes de conversion.

        prog    PROC    NEAR
                MOV     AX, DONNEES
                MOV     DS, AX

       boucle:
                saisir_nombre_AX

                afficher_nombre_AX

                ADD     AX, 1

                afficher_nombre_AX


                afficher_texte invite
                saisir_caractere BH                ; Saisie d'un caractere.
                CMP     BH, 'N'                    ; S'il s'agit de 'N' ou 'n',
                JE      fin                        ; fin du programme.
                CMP     BH, 'n'
                JE fin

                MOV     AX, offset boucle          ; Saut a longue distance.
                JMP     AX

           fin: MOV     AX, 4C00h
                INT     21h
        prog    ENDP
CODE    ENDS

END     prog
