; Programme assembleur pour 80x86 utilisant les macro-commandes.
; fichier ex-sais.asm.
; Saisie et affichage d'une chaine de caracteres.
; Bertrand Ducourthial. Mars 1998. Version 1.

ASSUME CS:CODE, DS:DONNEES

DONNEES SEGMENT
        invite1 DB      10,13,"Entrez une chaine de caracteres : $"
        invite2 DB      10,13,"Vous avez saisi : $"
        invite3 DB      10,13,"Voulez-vous recommencer (O/N) ? : $"
        saisie  DB      16 DUP(32) ; Chaine de 16 caracteres espace.
DONNEES ENDS

CODE    SEGMENT
                INCLUDE macinit.inc    ; Segment de donnees pour les macros.
                INCLUDE macaffi.inc    ; Macro-commandes d'affichage.
                INCLUDE macsais.inc    ; Macro-commandes de saisie.
                INCLUDE macconv.inc

        prog    PROC    NEAR
                MOV     AX, DONNEES
                MOV     DS, AX

       boucle:
                afficher_texte  invite1
                saisir_texte 13, saisie

                afficher_texte invite2
                afficher_texte saisie

                afficher_texte invite3
                saisir_caractere BH                ; Saisie d'un caractere.
                CMP     BH, 'N'                    ; S'il s'agit de 'N' ou 'n',
                JE      fin                        ; fin du programme.
                CMP     BH, 'n'
                JE fin

                MOV     AX, offset boucle          ; Saut a longue distance.
                JMP     AX

           fin: MOV     AX, 4C00h
                INT     21h
        prog    ENDP
CODE    ENDS

END     prog
