; Programme assembleur pour 80x86 utilisant les macro-commandes.
; fichier ex-affi.asm.
; Affichage de la pile.
; Bertrand Ducourthial. Fevrier 1998. Version 2.

ASSUME CS:CODE, DS:DONNEES

DONNEES SEGMENT
        ainvite1  DB     10,13,"Voici le contenu de la pile : $"
        ainvite2  DB     10,13,"  adresse : $"
        ainvite3  DB     "  contenu en hexa : $"
        ainvite4  DB     "  contenu en binaire : $"
        acontenu  DB     20 DUP(32) ; 20 caracteres espace.
DONNEES ENDS

PILE    SEGMENT STACK
        DW      100 DUP(?)
PILE    ENDS

CODE    SEGMENT
                INCLUDE macinit.inc   ; Segment de donnees pour les macros.
                INCLUDE macaffi.inc   ; Macro-commandes d'affichage.
                INCLUDE macconv.inc   ; Macro-commandes de conversion.
                INCLUDE macpile.inc   ; Macro-commandes d'affichage de la pile.

        prog    PROC    NEAR
                MOV     AX, DONNEES
                MOV     DS, AX

                MOV     AX, 1      ; Empilement de 1
                PUSH    AX
                MOV     AX, 2      ; Empilement de 2
                PUSH    AX
                MOV     AX, 3      ; Empilement de 3
                PUSH    AX
                MOV     AX, 4      ; Empilement de 4
                PUSH    AX

                afficher_pile 5    ; Affichage des 5 premieres lignes de la
                                   ; pile.

                MOV     AX, 4C00h
                INT     21h
        prog    ENDP
CODE    ENDS

END     prog
